
#include "local.h"
#include <stdio.h>
#include "timeout.h"

/*check_sum == 0 calculate it, print it out and exit*/
/*check_sum == 1, disabled*/
/* otherwise, time_ck returns (sum==checksum) */

/******************************************************************/
/* Check for un-adulterated em program,  should be only called by */
/* dos.  Return 99 if checksum has not been altered 		  */
/* Copyright (c) 1989 Sonnet Software, Inc., All rights reserved. */
/******************************************************************/
/* 07jul93krs */

extern int main();
extern int emex();
int em_csum;
static int em_check_sum = EM_CHECK_SUM;
#if EM_CHECK_SUM == 0 
static char *sum_str = "#define EM_CHECK_SUM %d\n";
#else
static char *sum_str = "                     %d\n";
#endif

chsm()
{

#if EM_CHECK_SUM == 1 && !defined(DOS)
	/* Just return correct value of 99 if not doing check sum	*/
	/* or if on UNX (i.e. not DOS) 					*/
	return(99);
#else

	/* The following must be declare static so that the value
        ** EM_CHECK_SUM is put into r/w memory, versus read only
	** memory
	*/
	int *begin, *end;
	int *pnt;
	FILE *file;

	/* 
	** make it a little more difficult for the hacker to find.  Do not
	** use the address of the first or last routine.
	*/
	begin = ((int *)main)+12;
	end = ((int *)emex)-11;
	em_csum = 0;
	for (pnt=begin; pnt<end; ++pnt) {
		em_csum ^= *pnt;
	}

	/*
	file = fopen("module","w");
	for (pnt=begin; pnt<end; ++pnt) {
		fprintf(file,"%x	%d\n",pnt, *pnt);
	}
	fclose(file);
	*/

	/* Must be able to add 99 without overflowing. */
	/* This is unlikely to happen but we must be sure */
	if ( (em_csum+99) - em_csum != 99 ) {
		printf("Bad value for  em_check_sum = %d\n",em_csum);
	}
	if ( em_check_sum == 0 ) {
		printf(sum_str,em_csum);
		em_check_sum = em_csum;
	}
	return( (em_check_sum+99)-em_csum);

#endif /* EM_CHECK_SUM */
}
